package de.joethei.hs.java2.praktikum.praktikum4;

import java.io.*;
import java.net.Socket;
import java.util.Arrays;
import java.util.List;

public class ClientRunnable implements Runnable{

    private Socket socket;
    private BufferedReader bufferedReader;

    public ClientRunnable(Socket socket) {
        this.socket = socket;
        try {
            bufferedReader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    @Override
    public void run() {
        System.out.println("client connected");
        try {
            String input = bufferedReader.readLine();
            System.out.println(input);
            BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream()));
            input = input.replace(",", "");
            List<String> arguments = Arrays.asList(input.split(" "));
            String command = arguments.remove(0);

            KlausurenServer.getCommands().get(command.toLowerCase()).handle(bufferedWriter, arguments);

            bufferedWriter.flush();
            bufferedWriter.close();
            socket.close();
            Thread.currentThread().interrupt();

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}